
#include <CapacitiveSensor.h>

//Touch Sensor variables
CapacitiveSensor   cs_2_3 = CapacitiveSensor(2,3);        // 1M resistor between pins 2 & 3, pin 3 is sensor pin, add a wire and or foil
CapacitiveSensor   cs_2_4 = CapacitiveSensor(2,4);        // 1M resistor between pins 2 & 4, pin 4 is sensor pin, add a wire and or foil
CapacitiveSensor   cs_2_5 = CapacitiveSensor(2,5);        // 1M resistor between pins 2 & 5, pin 5 is sensor pin, add a wire and or foil
CapacitiveSensor   cs_2_6 = CapacitiveSensor(2,6);  //4
CapacitiveSensor   cs_2_7 = CapacitiveSensor(2,7);  //5
CapacitiveSensor   cs_8_9 = CapacitiveSensor(8,9);   //6
CapacitiveSensor   cs_8_10 = CapacitiveSensor(8,10);   //7
CapacitiveSensor   cs_8_11 = CapacitiveSensor(8,11);  //8 
CapacitiveSensor   cs_8_12 = CapacitiveSensor(8,12);  //9
CapacitiveSensor   cs_8_13 = CapacitiveSensor(8,13);   //10
CapacitiveSensor   cs_14_15 = CapacitiveSensor(14,15);  //11
CapacitiveSensor   cs_14_16 = CapacitiveSensor(14,16);  //12
CapacitiveSensor   cs_14_17 = CapacitiveSensor(14,17);  //13      
CapacitiveSensor   cs_14_18 = CapacitiveSensor(14,18);  //14      
CapacitiveSensor   cs_14_19 = CapacitiveSensor(14,19);  //15 

const int samples = 60;
const int sensitivity = 250;

int state[15] = {0};

//Shift REgister Variables
//Clock and Data Pin for first Shift Register
const int clockPin1 = 35;//white wire
const int dataPin1 = 36; //yellow wire

//Clock and Data Pin for second Shift Register
const int clockPin2 = 37;
const int dataPin2 = 38;

//Clock and Data Pin for third Shift Register
const int clockPin3 = 38;
const int dataPin3 = 39;

//Clock and Data Pin for fourth Shift Register
const int clockPin4 = 40;
const int dataPin4 = 41;

//Clock and Data Pin for fifth Shift Register
const int clockPin5 = 42;
const int dataPin5 = 43;

//Clock and Data Pin for sixth Shift Register
const int clockPin6 = 44;
const int dataPin6 = 45;

//electromagnets
const int e1 = 20;
const int e2 = 21;
const int e3 = 22;
const int e4 = 23;
const int e5 = 24;
const int e6 = 25;
const int e7 = 26;
const int e8 = 27;
const int e9 = 28;
const int e10 = 29;
const int e11 = 30;
const int e12 = 31;
const int e13 = 32;
const int e14 = 33;
const int e15 = 34;


//shifRegister Data
word shift1= 0;
word shift2= 0;
word shift3= 0;

//Serial Variables
String inputString = "";         // a string to hold incoming data
boolean stringComplete = false;  // whether the string is complete

void setup() {
  //set pins to output because they are addressed in the main loop
  pinMode(dataPin1, OUTPUT);  
  pinMode(clockPin1, OUTPUT);
  pinMode(clockPin2, OUTPUT);
  pinMode(dataPin2, OUTPUT);
  
  pinMode(e1, OUTPUT);
  pinMode(e2, OUTPUT);
  pinMode(e3, OUTPUT);
  pinMode(e4, OUTPUT);
  pinMode(e5, OUTPUT);
  pinMode(e6, OUTPUT);
  pinMode(e7, OUTPUT);
  pinMode(e8, OUTPUT);
  pinMode(e9, OUTPUT);
  pinMode(e10, OUTPUT);
  pinMode(e11, OUTPUT);
  pinMode(e12, OUTPUT);
  pinMode(e13, OUTPUT);
  pinMode(e14, OUTPUT);
  pinMode(e15, OUTPUT);
  
  turnAllOff();
  
  Serial.begin(9600);
  inputString.reserve(200);
}


void loop() {
    long start = millis();
    long touch1 =  cs_2_3.capacitiveSensor(samples);
    long touch2 =  cs_2_4.capacitiveSensor(samples);
    long touch3 =  cs_2_5.capacitiveSensor(samples);
    long touch4 =  cs_2_6.capacitiveSensor(samples);
    long touch5 =  cs_2_7.capacitiveSensor(samples);
    long touch6 =  cs_8_9.capacitiveSensor(samples);
    long touch7 =  cs_8_10.capacitiveSensor(samples);
    long touch8 =  cs_8_11.capacitiveSensor(samples);
    long touch9 =  cs_8_12.capacitiveSensor(samples);
    long touch10 =  cs_8_13.capacitiveSensor(samples);
    long touch11 =  cs_14_15.capacitiveSensor(samples);
    long touch12 =  cs_14_16.capacitiveSensor(samples);
    long touch13 =  cs_14_17.capacitiveSensor(samples);
    long touch14 =  cs_14_18.capacitiveSensor(samples);
    long touch15 =  cs_14_19.capacitiveSensor(samples);
    
    if (touch1 > sensitivity){
      Serial.write('A');
      state[0] = 1;
    }
    else if ((touch1 <= sensitivity) && (state[0] == 1)){
      Serial.write('a');
      state[0]= 0;
    }
    
    if (touch2 > sensitivity){
      Serial.write('B');
      state[1] = 1;
    }
    else if ((touch2 <= sensitivity) && (state[1] == 1)){
      Serial.write('b');
      state[1]= 0;
    }
    
    if (touch3 > sensitivity){
      Serial.write('C');
      state[2] = 1;
    }
    else if ((touch3 <= sensitivity) && (state[2] == 1)){
      Serial.write('c');
      state[2]= 0;
    }
    
    if (touch4 > sensitivity){
      Serial.write('D');
      state[3] = 1;
    }
    else if ((touch4 <= sensitivity) && (state[3] == 1)){
      Serial.write('d');
      state[3]= 0;
    }
    
    if (touch5 > sensitivity){
      Serial.write('E');
      state[4] = 1;
    }
    else if ((touch5 <= sensitivity) && (state[4] == 1)){
      Serial.write('e');
      state[4]= 0;
    }
    
    if (touch6 > sensitivity){
      Serial.write('F');
      state[5] = 1;
    }
    else if ((touch6 <= sensitivity) && (state[5] == 1)){
      Serial.write('f');
      state[5]= 0;
    }
    
    if (touch7 > sensitivity){
      Serial.write('G');
      state[6] = 1;
    }
    else if ((touch7 <= sensitivity) && (state[6] == 1)){
      Serial.write('g');
      state[6]= 0;
    }
    
    if (touch8 > sensitivity){
      Serial.write('H');
      state[7] = 1;
    }
    else if ((touch8 <= sensitivity) && (state[7] == 1)){
      Serial.write('h');
      state[7]= 0;
    }
    
    if (touch9 > sensitivity){
      Serial.write('I');
      state[8] = 1;
    }
    else if ((touch9 <= sensitivity) && (state[8] == 1)){
      Serial.write('i');
      state[8]= 0;
    }
    
    if (touch10 > sensitivity){
      Serial.write('J');
      state[9] = 1;
    }
    else if ((touch10 <= sensitivity) && (state[9] == 1)){
      Serial.write('j');
      state[9]= 0;
    }
    
    if (touch11 > sensitivity){
      Serial.write('K');
      state[10] = 1;
    }
    else if ((touch11 <= sensitivity) && (state[10] == 1)){
      Serial.write('k');
      state[10]= 0;
    }
    
    if (touch12 > sensitivity){
      Serial.write('L');
      state[11] = 1;
    }
    else if ((touch12 <= sensitivity) && (state[11] == 1)){
      Serial.write('l');
      state[11]= 0;
    }
    
    if (touch13 > sensitivity){
      Serial.write('M');
      state[12] = 1;
    }
    else if ((touch13 <= sensitivity) && (state[12] == 1)){
      Serial.write('m');
      state[12]= 0;
    }
    
    if (touch14 > sensitivity){
      Serial.write('N');
      state[13] = 1;
    }
    else if ((touch14 <= sensitivity) && (state[13] == 1)){
      Serial.write('n');
      state[13]= 0;
    }
    
    if (touch15 > sensitivity){
      Serial.write('O');
      state[14] = 1;
    }
    else if ((touch15 <= sensitivity) && (state[14] == 1)){
      Serial.write('o');
      state[14]= 0;
    }
  
    if (stringComplete) {
    //Serial.println(inputString);
      pinWrite(inputString);
      // clear the string:
      inputString = "";
      stringComplete = false;
   }
}



//*****************************METHODS*****************************//

void pinWrite(String whichKey) {
  
  int key;
  
  if(whichKey.startsWith("R")){
    key = getKeyNumber(whichKey);
    colorWrite('R', key);
    pullOn(key);
  }
  if(whichKey.startsWith("G")){
    key = getKeyNumber(whichKey);
    colorWrite('G',key);
    pullOn(key);
  }
    
  if(whichKey.startsWith("B")){
    key = getKeyNumber(whichKey);
    colorWrite('B',key);
    pullOn(key);
  }
    
  if(whichKey.startsWith("C")){
    key = getKeyNumber(whichKey);
    colorWrite('C',key);
    pullOn(key);
  }
  
  if(whichKey.startsWith("M")){
    key = getKeyNumber(whichKey);
    colorWrite('M',key);
    pullOn(key);
  }
  
  if(whichKey.startsWith("O")){
    key = getKeyNumber(whichKey);
    colorWrite('O',key);
    pullOff(key);
  }   
}

//gets the number for the key that needs to be controlled
int getKeyNumber(String getKey){
  String number = "";
  int keyNum;
  
  number += (char)getKey.charAt(1);
  number += (char)getKey.charAt(2);
  keyNum = number.toInt();
  number = "";
  return keyNum;
  
}

//Get data from serial (MAX)  
void serialEvent() {
  while (Serial.available()) {
    // get the new byte:
    char inChar = (char)Serial.read(); 
    // add it to the inputString:
    inputString += inChar;
    // if the incoming character is a newline, set a flag
    // so the main loop can do something about it:
    if (inChar == '\n') {
      stringComplete = true;
    } 
  }
}
//turns on correct color
void colorWrite(char whichColor, int thisKey) {
// the bits you want to send
  byte bitsToSend = B000;
  word shifth = 0;
  word bitMask = getBitMask(thisKey);
  
  switch(whichColor){
    case 'R':
     bitsToSend = B001;
     break;
    case 'G':
     bitsToSend = B010; 
     break;
    case 'B':
     bitsToSend = B100; 
     break;
    case 'C':
     bitsToSend = B110; 
     break;
    case 'M':
     bitsToSend = B101; 
     break;
    case 'O':
     bitsToSend = B000; 
     break;
  }
  
  Serial.print("\t");
  Serial.print(bitsToSend,BIN);
  
  if(thisKey >=1 && thisKey < 6){
  shift1 = bitMask & shift1;
  shifth = bitsToSend << ((thisKey -1)*3);
  shift1 = shift1 | shifth;
  shiftBits(shift1, thisKey);
  }
  
  if(thisKey >=6 && thisKey < 11){
  shift2 = bitMask & shift2;
  shifth = bitsToSend << (((thisKey-5) -1)*3);//need to correct key number for second shift register group
  shift2 = shift2 | shifth;
  shiftBits(shift2, thisKey);
  }
  
  if(thisKey >=11 && thisKey < 16){
  shift3 = bitMask & shift3;
  shifth = bitsToSend << (((thisKey-10) -1)*3); //need to correct key number for third shift register group
  shift3 = shift3 | shifth;
  shiftBits(shift3, thisKey);
  }
}

word getBitMask(int keyNum){
  if((keyNum == 1) || (keyNum == 6) || (keyNum == 11))
    return 0xFFF8;//65528; //1111111111111000
  if((keyNum == 2) || (keyNum == 7) || (keyNum == 12))
    return 0xFFC7;//65479; //1111111111000111
  if((keyNum == 3) || (keyNum == 8) || (keyNum == 13))
    return 0xFE3F;//65087; //1111111000111111
  if((keyNum == 4) || (keyNum == 9) || (keyNum == 14))
    return 0xF1FF;//61951; //1111000111111111
  if((keyNum == 5) || (keyNum == 10) || (keyNum == 15))
    return 0x8FFF;//36863; //1000111111111111  
}

void shiftBits(word bytes, int thisShiftReg){
  
  if(thisShiftReg >=1 && thisShiftReg < 6){
  // shift the bits out:
  shiftOut(dataPin1, clockPin1, MSBFIRST, lowByte(bytes));
  shiftOut(dataPin2, clockPin2, MSBFIRST, highByte(bytes));
  }
  
  if(thisShiftReg >=6 && thisShiftReg < 11){
  // shift the bits out:
  shiftOut(dataPin3, clockPin3, MSBFIRST, lowByte(bytes));
  shiftOut(dataPin4, clockPin4, MSBFIRST, highByte(bytes));
  }
  
  if(thisShiftReg >=11 && thisShiftReg < 16){
  // shift the bits out:
  shiftOut(dataPin5, clockPin5, MSBFIRST, lowByte(bytes));
  shiftOut(dataPin6, clockPin6, MSBFIRST, highByte(bytes));
  }
}

//Electromagnet On
void pullOn(int thisKey){
  digitalWrite((thisKey+19),HIGH);
}
//Electromagnet Off
void pullOff(int thisKey){
  digitalWrite((thisKey+19),LOW);
}

//Turn LED and ELectromagnets off
void turnAllOff(){
  pinWrite("O01");
  pinWrite("O02");
  pinWrite("O03");
  pinWrite("O04");
  pinWrite("O05");
  pinWrite("O06");
  pinWrite("O07");
  pinWrite("O09");
  pinWrite("O10");
  pinWrite("O11");
  pinWrite("O12");
  pinWrite("O13");
  pinWrite("O14");
  pinWrite("O15");
}

